Bug 449812 - gnbd does explicitly disallow sending requests after a send has failed.
gnbd does explicitly disallow sending requests after a send has failed.
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: gnbd-kmod (Show other bugs)
All Linux
high Severity high
: rc
: ---
Assigned To: Ben Marzinski
Cluster QE
Depends On:
Blocks: 391501
  Show dependency treegraph
Reported: 2008-06-03 14:42 EDT by Ben Marzinski
Modified: 2010-10-22 21:40 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2009-01-20 16:08:25 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
patch to disallow sending requests after a send has failed. (1.68 KB, patch)
2008-06-03 14:50 EDT, Ben Marzinski
no flags Details | Diff

  None (edit)
Description Ben Marzinski 2008-06-03 14:42:51 EDT
Description of problem:
GNBD assumes that after a send to a socket has a failed due to a socket error,
future sends or receives on the socket will also fail.  If this doesn't happen,
it is possible to send garbage to the gnbd server.

Version-Release number of selected component (if applicable):

How reproducible:
Not sure.  A customer has seen GNBD_REQUEST_MAGIC mismatched errors likely
stemming from this.

Additional info:
This bug was initially mentioned in comment #14 of bz #444074, but it is
unrelated to the issue that the bugzilla was opened to track.
Comment 1 Ben Marzinski 2008-06-03 14:50:20 EDT
Created attachment 308279 [details]
patch to disallow sending requests after a send has failed.

This patch adds a "corrupt" flag to the gnbd device structure.	This flag is
cleared when a new socket connection is opened to the server. It is set
a send fails.  After this all future sends will fail, and the receiver process
will stop accepting replies as soon as it notices the flag.
Comment 2 RHEL Product and Program Management 2008-06-05 15:54:45 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
Comment 5 Fedora Update System 2008-07-30 16:03:49 EDT
gfs2-utils-2.03.05-1.fc9, rgmanager-2.03.05-1.fc9, cman-2.03.05-1.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 10 errata-xmlrpc 2009-01-20 16:08:25 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.